<?php
/**
 * OnPay.ru payment system driver.
 *
 * Fail payment hook.<br />
 * Onpay requires success/fail payment callback scripts
 * to have no GET parameters.
 *
 * <lang:ru>
 * Скрипт, который будет запрошен системой OnPay в случае непрохождения платежа.
 * </lang:ru>
 *
 * @copyright atonator.com. All rights reserved.
 * @category  ATO
 * @package   Driver_PaymentSystem
 * @version   1.0
 * @see       AtoOnpay_PaymentSystemDriver::getPayButtonParams()
 */

require_once 'ami_env.php';

/**
 * @var AMI_Response
 */
$oResponse = AMI::getSingleton('response');
$oResponse->start();

/**
 * @var AMI_RequestHTTP
 */
$oRequest = AMI::getSingleton('env/request');

if ($oRequest->getCookie('ato_onpay_order')) {
    require_once dirname(__FILE__) . '/_local/eshop/AtoPaymentSystem.php';

    $secretKey = AtoPaymentSystem::getDriverParameter(
        'ato_onpay',
        'onpay_secret_key'
    );
    /*
        In 5.12.4 Amiro session is buggly, using cookie to pass data
        from AtoOnpay_PaymentSystemDriver::getPayButtonParams().

        <lang:ru>
        Передать через сессионные переменные Amiro в версии 5.12.4
        не получилось, поэтому пришлось передавать данные с подписью через
        cookie.
        </lang:ru>
     */
    list ($data, $sign) = explode('|', $oRequest->getCookie('ato_onpay_order'), 2);
    if (md5($data . 'ato_onpay' . $secretKey) === $sign){
        $oResponse->HTTP->setCookie('ato_onpay_order', NULL);
        $oResponse->HTTP->setCookie('ato_onpay_order', NULL);
        $order = @unserialize(gzuncompress(base64_decode($data)));
        if (is_array($order) && isset($order['fail'])) {
            /*
                Redirect to Amiro.CMS fail URL.

                <lang:ru>
                Перенаправление на URL, переданный Amiro.CMS для установки
                факта непрохождения платежа.
                </lang:ru>
            */
            ob_end_clean();
            header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
            header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT');
            header('Cache-Control: post-check=0, pre-check=0', false);
            header('Pragma: no-cache'); // HTTP/1.0
            header('Location: ' . $order['fail'], true, 301);
            die;
        }
    }
}

$oResponse->send();
